Index: trunk/anuga_core/source/anuga/fit_interpolate/fit.py
===================================================================
--- trunk/anuga_core/source/anuga/fit_interpolate/fit.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/fit_interpolate/fit.py	(revision 8690)
@@ -28,14 +28,12 @@
 
 from anuga.abstract_2d_finite_volumes.neighbour_mesh import Mesh
-from anuga.caching import cache            
+from anuga.caching import cache
 from anuga.geospatial_data.geospatial_data import Geospatial_data, \
      ensure_absolute
 from anuga.fit_interpolate.general_fit_interpolate import FitInterpolate
-from anuga.utilities.sparse import Sparse, Sparse_CSR
-from anuga.geometry.polygon import inside_polygon, is_inside_polygon
-from anuga.pmesh.mesh_quadtree import MeshQuadtree
-
+
+from anuga.utilities.sparse import Sparse_CSR
+from anuga.utilities.numerical_tools import ensure_numeric
 from anuga.utilities.cg_solve import conjugate_gradient
-from anuga.utilities.numerical_tools import ensure_numeric, gradient
 from anuga.config import default_smoothing_parameter as DEFAULT_ALPHA
 import anuga.utilities.log as log
@@ -48,7 +46,32 @@
 import sys
 
+# Setup for c fitting routines
+from anuga.utilities import compile
+if compile.can_use_C_extension('fitsmooth.c'):
+    import fitsmooth
+else:
+    msg = "C implementation of fitting algorithms (fitsmooth.c) not avalaible"
+    raise Exception(msg)
+
+# Setup for quad_tree extension
+from anuga.utilities import compile
+if compile.can_use_C_extension('quad_tree_ext.c'):
+    import quad_tree_ext
+else:
+    msg = "C implementation of quad tree extension not avaliable"
+    raise Exception(msg)
+
+# Setup for sparse_matrix extension
+from anuga.utilities import compile
+if compile.can_use_C_extension('sparse_matrix_ext.c'):
+    import sparse_matrix_ext
+else:
+    msg = "C implementation of sparse_matrix extension not avaliable"
+    raise Exception(msg)
+
+
 
 class Fit(FitInterpolate):
-    
+
     def __init__(self,
                  vertex_coordinates=None,
@@ -56,9 +79,14 @@
                  mesh=None,
                  mesh_origin=None,
-                 alpha = None,
-                 verbose=False):
-
+                 alpha=None,
+                 verbose=False,
+                 cg_precon='None',
+                 use_c_cg=True):
 
         """
+        Padarn Note 05/12/12: This documentation should probably
+        be updated to account for the fact that the fitting is now
+        done in c. I wasn't sure what details were neccesary though.
+
         Fit data at points to the vertices of a mesh.
 
@@ -66,5 +94,5 @@
 
           vertex_coordinates: List of coordinate pairs [xi, eta] of
-	      points constituting a mesh (or an m x 2 numeric array or
+          points constituting a mesh (or an m x 2 numeric array or
               a geospatial object)
               Points may appear multiple times
@@ -73,7 +101,4 @@
           triangles: List of 3-tuples (or a numeric array) of
               integers representing indices of all vertices in the mesh.
-
-          mesh: Object containing vertex_coordinates and triangles. Either
-              mesh = None or both vertex_coordinates and triangles = None
 
           mesh_origin: A geo_reference object or 3-tuples consisting of
@@ -89,12 +114,11 @@
         To use this in a blocking way, call  build_fit_subset, with z info,
         and then fit, with no point coord, z info.
-        
         """
         # Initialise variabels
         if alpha is None:
             self.alpha = DEFAULT_ALPHA
-        else:    
+        else:
             self.alpha = alpha
-            
+
         FitInterpolate.__init__(self,
                  vertex_coordinates,
@@ -103,59 +127,45 @@
                  mesh_origin=mesh_origin,
                  verbose=verbose)
-        
-        m = self.mesh.number_of_nodes # Nbr of basis functions (vertices)
-        
+
         self.AtA = None
         self.Atz = None
-
+        self.D = None
         self.point_count = 0
-        if self.alpha <> 0:
-            if verbose: log.critical('Fit: Building smoothing matrix')
-            self._build_smoothing_matrix_D(verbose=verbose)
-
-        if verbose: log.critical('Fit: Get Boundary Polygon')
-        bd_poly = self.mesh.get_boundary_polygon()    
+
+        # NOTE PADARN: NEEDS FIXING - currently need smoothing matrix
+        # even if alpha is zero, due to c function expecting it. This
+        # could and should be removed.
+        if True:
+            if verbose:
+                log.critical('Building smoothing matrix')
+            self.D = self._build_smoothing_matrix_D()
+
+        bd_poly = self.mesh.get_boundary_polygon()
         self.mesh_boundary_polygon = ensure_numeric(bd_poly)
 
-        if verbose: log.critical('Fit: Done')
-
-            
+        self.cg_precon=cg_precon
+        self.use_c_cg=use_c_cg
+
     def _build_coefficient_matrix_B(self,
-                                  verbose = False):
+                                  verbose=False):
         """
-        Build final coefficient matrix
-
-        Precon
-        If alpha is not zero, matrix D has been built
-        Matrix Ata has been built
+        Build final coefficient matrix from AtA and D
         """
 
-        if verbose:
-            import time
-            t0 = time.time()
-            print 'Fit: Build Coefficient Matrix B ',
-
-
-        if self.alpha <> 0:
-            #if verbose: log.critical('Building smoothing matrix')
-            #self._build_smoothing_matrix_D()
-            # FIXME SR: This is quite time consuming.
-            # As AtA and D have same structure it should be possible
-            # to speed this up.
-            self.B = self.AtA + self.alpha*self.D
-        else:
-            self.B = self.AtA
-
-
-        if verbose:
-            import time
-            dt = time.time()-t0
-            print '%g secs' % dt
-            print 'Fit: Convert Coefficient Matrix B to Sparse_CSR'
-            
-        # Convert self.B matrix to CSR format for faster matrix vector
-        self.B = Sparse_CSR(self.B)
-
-    def _build_smoothing_matrix_D(self, verbose=False):
+        msize = self.mesh.number_of_nodes
+
+        self.B = fitsmooth.build_matrix_B(self.D, \
+                                          self.AtA, self.alpha)
+
+        # Convert self.B matrix to CSR format
+        self.B = Sparse_CSR(data=num.array(self.B[0]),\
+                                  Colind=num.array(self.B[1]),\
+                                  rowptr=num.array(self.B[2]), \
+                                  m=msize, n=msize)
+        # NOTE PADARN: The above step could potentially be removed
+        # and the sparse matrix worked with directly in C. Not sure
+        # if this would be worthwhile.
+
+    def _build_smoothing_matrix_D(self):
         """Build m x m smoothing matrix, where
         m is the number of basis functions phi_k (one per vertex)
@@ -181,87 +191,32 @@
         \frac{\partial \phi_k}{\partial x} for a particular triangle
         are obtained by computing the gradient a_k, b_k for basis function k
+
+        NOTE PADARN: All of this is now done in an external C function, and the
+        result is stored in a Capsule object, meaning the entries cannot be directly
+        accessed.
         """
-        
-        # FIXME: algorithm might be optimised by computing local 9x9
-        # "element stiffness matrices:
-
-        m = self.mesh.number_of_nodes # Nbr of basis functions (1/vertex)
-
-        self.D = Sparse(m,m)
-
-        import time
-        t0 = time.time()
-
-        if verbose :
-            print '['+60*' '+']',
-            sys.stdout.flush()
-
-        N = len(self.mesh)
-        M = N/60
-
-        # For each triangle compute contributions to D = D1+D2
-        for i in xrange(N):
-
-            if verbose and i%M == 0 :
-                #restart_line()
-                print '\r['+(i/M)*'.'+(60-(i/M))*' ' +']',
-                sys.stdout.flush()
-
-            # Get area
-            area = self.mesh.areas[i]
-
-            # Get global vertex indices
-            v0 = self.mesh.triangles[i,0]
-            v1 = self.mesh.triangles[i,1]
-            v2 = self.mesh.triangles[i,2]
-
-            # Get the three vertex_points
-            xi0 = self.mesh.get_vertex_coordinate(i, 0)
-            xi1 = self.mesh.get_vertex_coordinate(i, 1)
-            xi2 = self.mesh.get_vertex_coordinate(i, 2)
-
-            # Compute gradients for each vertex
-            a0, b0 = gradient(xi0[0], xi0[1], xi1[0], xi1[1], xi2[0], xi2[1],
-                              1, 0, 0)
-
-            a1, b1 = gradient(xi0[0], xi0[1], xi1[0], xi1[1], xi2[0], xi2[1],
-                              0, 1, 0)
-
-            a2, b2 = gradient(xi0[0], xi0[1], xi1[0], xi1[1], xi2[0], xi2[1],
-                              0, 0, 1)
-
-            # Compute diagonal contributions
-            self.D[v0,v0] += (a0*a0 + b0*b0)*area
-            self.D[v1,v1] += (a1*a1 + b1*b1)*area
-            self.D[v2,v2] += (a2*a2 + b2*b2)*area
-
-            # Compute contributions for basis functions sharing edges
-            e01 = (a0*a1 + b0*b1)*area
-            self.D[v0,v1] += e01
-            self.D[v1,v0] += e01
-
-            e12 = (a1*a2 + b1*b2)*area
-            self.D[v1,v2] += e12
-            self.D[v2,v1] += e12
-
-            e20 = (a2*a0 + b2*b0)*area
-            self.D[v2,v0] += e20
-            self.D[v0,v2] += e20
-
-        if verbose:
-            print ' %f secs' % (time.time()-t0)
-
+
+        # NOTE PADARN: Should the input arguments here be checked - making
+        # sure that they are floats? Not sure if this is done elsewhere.
+        # NOTE PADARN: Should global coordinates be used for the smoothing
+        # matrix, or is thids not important?
+        return fitsmooth.build_smoothing_matrix(self.mesh.triangles, \
+          self.mesh.areas, self.mesh.vertex_coordinates)
+
+
+    # NOTE PADARN: This function was added to emulate behavior of the original
+    # class not using external c functions. This method is dangerous as D could
+    # be very large - it was added as it is used in a unit test.
     def get_D(self):
-        return self.D.todense()
-
-
-
-    def _build_matrix_AtA_Atz(self,
-                              point_coordinates,
-                              z,
-                              verbose = False,
-                              output=None):
-
-
+        return fitsmooth.return_full_D(self.D, self.mesh.number_of_nodes)
+
+    # NOTE PADARN: This function was added to emulate behavior of the original
+    # class so as to pass a unit test. It is completely uneeded.
+    def build_fit_subset(self, point_coordinates, z=None, attribute_name=None,
+                              verbose=False, output='dot'):
+        self._build_matrix_AtA_Atz(point_coordinates, z, attribute_name, verbose, output)
+
+    def _build_matrix_AtA_Atz(self, point_coordinates, z=None, attribute_name=None,
+                              verbose=False, output='dot'):
         """Build:
         AtA  m x m  interpolation matrix, and,
@@ -277,5 +232,5 @@
         This function can be called again and again, with sub-sets of
         the point coordinates.  Call fit to get the results.
-        
+
         Preconditions
         z and points are numeric
@@ -285,108 +240,116 @@
         """
 
-
-        if verbose and output == 'counter':
-            print 'Fit: Build Matrix AtA Atz'
-
-        import time
-        t0 = time.time()
-
-        # Build n x m interpolation matrix
-        if self.AtA == None:
-            # AtA and Atz need to be initialised.
-            m = self.mesh.number_of_nodes
-            if len(z.shape) > 1:
-                att_num = z.shape[1]
-                self.Atz = num.zeros((m,att_num), num.float)
+        if isinstance(point_coordinates, Geospatial_data):
+            point_coordinates = point_coordinates.get_data_points( \
+                absolute=True)
+
+        # Convert input to numeric arrays
+        if z is not None:
+            z = ensure_numeric(z, num.float)
+        else:
+            msg = 'z not specified'
+            assert isinstance(point_coordinates, Geospatial_data), msg
+            z = point_coordinates.get_attributes(attribute_name)
+
+        point_coordinates = ensure_numeric(point_coordinates, num.float)
+
+        npts = len(z)
+        z = num.array(z)
+        # NOTE PADARN : This copy might be needed to
+        # make sure memory is contig - would be better to read in C..
+        z = z.copy()
+
+        self.point_count += z.shape[0]
+
+        zdim = 1
+        if len(z.shape) != 1:
+            zdim = z.shape[1]
+
+        [AtA, Atz] = fitsmooth.build_matrix_AtA_Atz_points(self.root.root, \
+               self.mesh.number_of_nodes, \
+               self.mesh.triangles, \
+               num.array(point_coordinates), z, zdim, npts)
+
+        if verbose and output == 'dot':
+            print '\b.',
+            sys.stdout.flush()
+        if zdim == 1:
+            Atz = num.array(Atz[0])
+        else:
+            Atz = num.array(Atz).transpose()
+
+        if self.AtA is None and self.Atz is None:
+            self.AtA = AtA
+            self.Atz = Atz
+        else:
+            fitsmooth.combine_partial_AtA_Atz(self.AtA, AtA,\
+                    self.Atz, Atz, zdim, self.mesh.number_of_nodes)
+
+    def _build_matrix_AtA_Atz_file(self, filename, attribute_name=None, max_read_lines=500,\
+                                   verbose=False):
+        """Build:
+        AtA  m x m  interpolation matrix, and,
+        Atz  m x a  interpolation matrix where,
+        m is the number of basis functions phi_k (one per vertex)
+        a is the number of data attributes
+
+        This algorithm uses a quad tree data structure for fast binning of
+        data points.
+
+        If Ata is None, the matrices AtA and Atz are created.
+
+        This function can be called again and again, with sub-sets of
+        the point coordinates.  Call fit to get the results.
+
+        Preconditions
+        z and points are numeric
+        Point_coordindates and mesh vertices have the same origin.
+
+        The number of attributes of the data points does not change
+        """
+        # PADARN NOTE: THe following block of code is translated from
+        # things that were being done in the Geospatial_data object
+        # which is no longer required if data from file in c.
+        #---------------------------------------------------------
+        # Default attribute name here seems to only have possibility
+        # of being 'None'.
+        G_data = Geospatial_data(filename,
+                                         max_read_lines=1,
+                                         load_file_now=True,
+                                         verbose=verbose)
+
+
+        if attribute_name is None:
+            if G_data.default_attribute_name is not None:
+                attribute_name = G_data.default_attribute_name
             else:
-                att_num = 1
-                self.Atz = num.zeros((m,), num.float)
-            assert z.shape[0] == point_coordinates.shape[0] 
-
-            AtA = Sparse(m,m)
-            # The memory damage has been done by now.
-        else:
-             AtA = self.AtA # Did this for speed, did ~nothing
-        self.point_count += point_coordinates.shape[0]
-
-
-        inside_indices = inside_polygon(point_coordinates,
-                                        self.mesh_boundary_polygon,
-                                        closed=True,
-                                        verbose=False) # Suppress output
-        
-        n = len(inside_indices)
-
-        # Compute matrix elements for points inside the mesh
-        triangles = self.mesh.triangles # Shorthand
-
-
-        if verbose and output == 'counter' :
-            print '['+60*' '+']',
-            #print '\b.',
-            sys.stdout.flush()
-
-        m = max(n/60,1)
-
-
-        for d in xrange(n):
-            i = inside_indices[d]
-
-#        for d, i in enumerate(inside_indices):
-#            # For each data_coordinate point
-#            # if verbose and d%((n+10)/10)==0: log.critical('Doing %d of %d'
-#                                                            # %(d, n))
-#            x = point_coordinates[i]
-
-            # For each data_coordinate point
-            # if verbose and d%((n+10)/10)==0: log.critical('Doing %d of %d'
-                                                            # %(d, n))
-
-
-            if verbose and output == 'counter' and i%m == 0 :
-                print '\r['+(i/m)*'.'+(60-(i/m))*' '+']',
-                sys.stdout.flush()
-
-
-            x = point_coordinates[i]
-            
-            element_found, sigma0, sigma1, sigma2, k = \
-                           self.root.search_fast(x)
-            
-            if element_found is True:
-                j0 = triangles[k,0] # Global vertex id for sigma0
-                j1 = triangles[k,1] # Global vertex id for sigma1
-                j2 = triangles[k,2] # Global vertex id for sigma2
-
-                sigmas = {j0:sigma0, j1:sigma1, j2:sigma2}
-                js     = [j0,j1,j2]
-
-                for j in js:
-                    self.Atz[j] +=  sigmas[j]*z[i]
-                    
-                    for k in js:
-                        AtA[j,k] += sigmas[j]*sigmas[k]
-            else:
-                flag = is_inside_polygon(x,
-                                         self.mesh_boundary_polygon,
-                                         closed=True,
-                                         verbose=False) # Suppress output
-                msg = 'Point (%f, %f) is not inside mesh boundary' % tuple(x)
-                assert flag is True, msg                
-                
-                # data point has fallen within a hole - so ignore it.
-
-
-        if verbose and output == 'counter':
-            print ' %f secs' % (time.time()-t0)
-            
+                attribute_name = G_data.attributes.keys()[0]
+                # above line takes the first one from keys
+
+        if verbose is True:
+            log.critical('Using attribute %s' % attribute_name)
+            log.critical('Available attributes: %s' % (G_data.attributes.keys()))
+
+        msg = 'Attribute name %s does not exist in data set' % attribute_name
+        assert G_data.attributes.has_key(attribute_name), msg
+        #---------------------------------------------------------
+
+        # MAKE SURE READING ABSOLUTE POINT COORDINATES
+        [AtA, Atz, npts] = fitsmooth.build_matrix_AtA_Atz_fileread(self.root.root, \
+               self.mesh.number_of_nodes, \
+               self.mesh.triangles, \
+               filename, \
+               attribute_name, \
+               max_read_lines)
+        self.point_count = npts
         self.AtA = AtA
-
-        
+        self.Atz = Atz
+
     def fit(self, point_coordinates_or_filename=None, z=None,
             verbose=False,
             point_origin=None,
             attribute_name=None,
-            max_read_lines=None):
+            max_read_lines=500,
+            use_blocking_option2=True):
         """Fit a smooth surface to given 1d array of data points z.
 
@@ -397,73 +360,70 @@
         point_coordinates: The co-ordinates of the data points.
               List of coordinate pairs [x, y] of
-	      data points or an nx2 numeric array or a Geospatial_data object
-              or points file filename 
+        data points or an nx2 numeric array or a Geospatial_data object
+              or points file filename
           z: Single 1d vector or array of data at the point_coordinates.
-          
+
         """
-
-
-        if verbose:
-            print 'Fit.fit: Initializing'
-
-        # Use blocking to load in the point info
         if isinstance(point_coordinates_or_filename, basestring):
-            msg = "Don't set a point origin when reading from a file"
-            assert point_origin is None, msg
-            filename = point_coordinates_or_filename
-
-            G_data = Geospatial_data(filename,
-                                     max_read_lines=max_read_lines,
-                                     load_file_now=False,
-                                     verbose=verbose)
-
-
-            for i, geo_block in enumerate(G_data):
-
-                if verbose is True and 0 == i%200:
-                    pass
-                    # The time this will take
-                    # is dependant on the # of Triangles
-                        
-                    #log.critical('Processing Block %d' % i)
-                    # FIXME (Ole): It would be good to say how many blocks
-                    # there are here. But this is no longer necessary
-                    # for pts files as they are reported in geospatial_data
-                    # I suggest deleting this verbose output and make
-                    # Geospatial_data more informative for txt files.
-                    #
-                    # I still think so (12/12/7, Ole).
-            
-
-                    
-                # Build the array
-
-                points = geo_block.get_data_points(absolute=True)
-                z = geo_block.get_attributes(attribute_name=attribute_name)
-                self.build_fit_subset(points, z, attribute_name, verbose)
-
-
-                # FIXME(Ole): I thought this test would make sense here
-                # See test_fitting_example_that_crashed_2 in test_shallow_water_domain.py
-                # Committed 11 March 2009
-                msg = 'Matrix AtA was not built'
-                assert self.AtA is not None, msg
-
-            point_coordinates = None
-
-            if verbose: print ''
-            
+            if point_coordinates_or_filename[-4:] != ".pts":
+                use_blocking_option2 = False
+        # NOTE PADARN 12/12/12: Currently trying to get all blocking to be done
+        # in c, but blocking option 1, which does everything using the python
+        # interface can be used in the meantime (much slower).
+        #-----------------------BLOCKING OPTION 1----------------------------
+        if use_blocking_option2 is False:
+            if verbose:
+                print 'Fit.fit: Initializing'
+
+            # Use blocking to load in the point info
+            if isinstance(point_coordinates_or_filename, basestring):
+                msg = "Don't set a point origin when reading from a file"
+                assert point_origin is None, msg
+                filename = point_coordinates_or_filename
+
+                G_data = Geospatial_data(filename,
+                                         max_read_lines=max_read_lines,
+                                         load_file_now=False,
+                                         verbose=verbose)
+
+                for i, geo_block in enumerate(G_data):
+
+                   # Build the array
+                    points = geo_block.get_data_points(absolute=True)
+                    z = geo_block.get_attributes(attribute_name=attribute_name)
+
+                    self._build_matrix_AtA_Atz(points, z, attribute_name, verbose)
+
+                point_coordinates = None
+
+                if verbose:
+                    print ''
+            else:
+                point_coordinates = point_coordinates_or_filename
+        #-----------------------BLOCKING OPTION 2----------------------------
         else:
-            point_coordinates =  point_coordinates_or_filename
-
-
-
+            if verbose:
+                print 'Fit.fit: Initializing'
+
+            if isinstance(point_coordinates_or_filename, basestring):
+                msg = "Don't set a point origin when reading from a file"
+                assert point_origin is None, msg
+                filename = point_coordinates_or_filename
+
+                self._build_matrix_AtA_Atz_file(filename, attribute_name=attribute_name,\
+                                                verbose=verbose)
+
+                point_coordinates = None
+            else:
+                point_coordinates = point_coordinates_or_filename
+        #--------------------------------------------------------------------
 
         if point_coordinates is None:
-            if verbose: log.critical('Fit.fit: Warning: no data points in fit')
+            if verbose:
+                log.critical('Fit.fit: Warning: no data points in fit')
             msg = 'No interpolation matrix.'
             assert self.AtA is not None, msg
             assert self.Atz is not None
-            
+
             # FIXME (DSG) - do  a message
         else:
@@ -472,21 +432,17 @@
             # if isinstance(point_coordinates,Geospatial_data) and z is None:
             # z will come from the geo-ref
-            self.build_fit_subset(point_coordinates, z, verbose=verbose, output='counter')
-
-
-
-
+
+            self._build_matrix_AtA_Atz(point_coordinates, z, verbose=verbose, output='counter')
 
         # Check sanity
-        m = self.mesh.number_of_nodes # Nbr of basis functions (1/vertex)
+        m = self.mesh.number_of_nodes  # Nbr of basis functions (1/vertex)
         n = self.point_count
-        if n<m and self.alpha == 0.0:
+        if n < m and self.alpha == 0.0:
             msg = 'ERROR (least_squares): Too few data points\n'
-            msg += 'There are only %d data points and alpha == 0. ' %n
-	    msg += 'Need at least %d\n' %m
+            msg += 'There are only %d data points and alpha == 0. ' % n
+            msg += 'Need at least %d\n' % m
             msg += 'Alternatively, set smoothing parameter alpha to a small '
-	    msg += 'positive value,\ne.g. 1.0e-3.'
+            msg += 'positive value,\ne.g. 1.0e-3.'
             raise TooFewPointsError(msg)
-
 
         self._build_coefficient_matrix_B(verbose)
